function AppCategoriesAssistant(item)
{
	this.item = item;
	this.categoryModel = {items:[]};
	
	// spinner model
	this.spinnerModel = {spinning: true};
}

AppCategoriesAssistant.prototype.setup = function()
{
	// setup spinner model
	this.controller.setupWidget('spinner', {spinnerSize: 'large'}, this.spinnerModel);
	
	// setup list widget
	this.controller.setupWidget('categoryList', { itemTemplate: "app-categories/rowTemplate", swipeToDelete: false, reorderable: false }, this.categoryModel);
	Mojo.Event.listen(this.controller.get('categoryList'), Mojo.Event.listTap, this.listTapHandler.bindAsEventListener(this));
	
	// hide the list while we update ipkg
	this.controller.get('categoryList').style.display = "none";
	
	// update the list
	IPKGService.list_categories(this.onList.bindAsEventListener(this));

}

AppCategoriesAssistant.prototype.listTapHandler = function(event)
{
	var item = {scene: 'app-list', category: event.item.name.toLowerCase(), name: event.item.name + " Applications", list: 'info'};
	this.controller.stageController.pushScene(item.scene, item);
}

AppCategoriesAssistant.prototype.onList = function(payload)
{
	if (!payload)
		// error / no apps
		return;
	else 
	{
		for (var x = 0; x < payload.categories.length; x++)
		{
			this.categoryModel.items.push(
			{
				name: payload.categories[x].substr(0, 1).toUpperCase() + payload.categories[x].substr(1),
			});
		}

		// stop and hide the spinner
		this.spinnerModel.spinning = false;
		this.controller.modelChanged(this.spinnerModel);
		this.controller.get('spinner').style.display = "none";
		
		// show the list
		this.controller.get('categoryList').style.display = "inline";
		
		// update list widget
		this.categoryModel.items.sort(function(a, b)
		{
			return ((a.name.toLowerCase() < b.name.toLowerCase()) ? -1 : ((a.name.toLowerCase() > b.name.toLowerCase()) ? 1 : 0));
		});
		this.controller.get('categoryList').mojo.noticeUpdatedItems(0, this.categoryModel.items);
	}
}

AppCategoriesAssistant.prototype.activate = function(event) {}

AppCategoriesAssistant.prototype.deactivate = function(event) {}

AppCategoriesAssistant.prototype.cleanup = function(event) {}
